/////////////////////////////////////////////////////////////////////////////
// TestRhinoPluginCPPPlugIn.cpp : defines the initialization routines for the plug-in.
//

#include "StdAfx.h"
#include "TestRhinoPluginCPPPlugIn.h"

#pragma warning( push )
#pragma warning( disable : 4073 )
#pragma init_seg( lib )
#pragma warning( pop )

// Rhino plug-in declaration
RHINO_PLUG_IN_DECLARE

// Rhino plug-in name
// Provide a short, friendly name for this plug-in.
RHINO_PLUG_IN_NAME( L"TestRhinoPluginCPP 1.0" );

// Rhino plug-in id
// Provide a unique uuid for this plug-in
RHINO_PLUG_IN_ID( L"D39FBBED-2B44-4816-8754-333DAC23431F" );

// Rhino plug-in version
// Provide a version number string for this plug-in
RHINO_PLUG_IN_VERSION( __DATE__"  "__TIME__ )

// Rhino plug-in developer declarations
RHINO_PLUG_IN_DEVELOPER_ORGANIZATION( L"Robert McNeel & Associates" );
RHINO_PLUG_IN_DEVELOPER_ADDRESS( L"3670 Woodland Park Avenue North\015\012Seattle WA 98103" );
RHINO_PLUG_IN_DEVELOPER_COUNTRY( L"United States" );
RHINO_PLUG_IN_DEVELOPER_PHONE( L"206-545-6877" );
RHINO_PLUG_IN_DEVELOPER_FAX( L"206-545-7321" );
RHINO_PLUG_IN_DEVELOPER_EMAIL( L"tech@mcneel.com" );
RHINO_PLUG_IN_DEVELOPER_WEBSITE( L"http://www.rhino3d.com" );
RHINO_PLUG_IN_UPDATE_URL( L"http://www.rhino3d.com/download" );

// The one and only CTestRhinoPluginCPPPlugIn object
static CTestRhinoPluginCPPPlugIn thePlugIn;

/////////////////////////////////////////////////////////////////////////////
// CTestRhinoPluginCPPPlugIn definition

CTestRhinoPluginCPPPlugIn& TestRhinoPluginCPPPlugIn()
{ 
  // Return a reference to the one and only CTestRhinoPluginCPPPlugIn object
  return thePlugIn; 
}

CTestRhinoPluginCPPPlugIn::CTestRhinoPluginCPPPlugIn()
{
  // TODO: Add construction code here
  m_plugin_version = RhinoPlugInVersion();
}

CTestRhinoPluginCPPPlugIn::~CTestRhinoPluginCPPPlugIn()
{
  // TODO: Add destruction code here
}

/////////////////////////////////////////////////////////////////////////////
// Required overrides

const wchar_t* CTestRhinoPluginCPPPlugIn::PlugInName() const
{
  // TODO: Return a short, friendly name for the plug-in.
  return RhinoPlugInName();
}

const wchar_t* CTestRhinoPluginCPPPlugIn::PlugInVersion() const
{
  // TODO: Return the version number of the plug-in.
  return m_plugin_version;
}

GUID CTestRhinoPluginCPPPlugIn::PlugInID() const
{
  // TODO: Return a unique identifier for the plug-in.
  // {D39FBBED-2B44-4816-8754-333DAC23431F}
  return ON_UuidFromString( RhinoPlugInId() );
}

BOOL CTestRhinoPluginCPPPlugIn::OnLoadPlugIn()
{
  // Ask Rhino to get a product license for us.
  bool rc = GetLicense();
  if( !rc )
    return -1; // Unable to initialize, unload the plug-in
               // and do not display load error dialog 

  // TODO: Add plug-in initialization code here.
  return CRhinoUtilityPlugIn::OnLoadPlugIn();
}

void CTestRhinoPluginCPPPlugIn::OnUnloadPlugIn()
{
  // TODO: Add plug-in cleanup code here.

  CRhinoUtilityPlugIn::OnUnloadPlugIn();
}

